/*
 * CS559 Maze Project
 *
 * Class header file for the MapWigdet class. A widget class for
 * displaying a map of the maze.
 *
 * (c) Stephen Chenney, University of Wisconsin at Madison, 2001-2002
 *
 */

#ifndef _MAPWIDGET_H_
#define _MAPWIDGET_H_

#include <Fl/Fl.h>
#include <Fl/Fl_Widget.h>
#include "Maze.h"

class MapWidget : public Fl_Widget {
    public:
	Maze	*maze;	// The maze to display

	// Constructor: Takes window position and size, the widget label,
	// and a maze (which can be NULL.)
	MapWidget(int x, int y, int w, int h, char *label, Maze *m);


	// draw() method for the widget
	void	draw(void);

	// Draws the view frustum on the map
	void	Draw_Frustum(void);

	// Gets rid of the view frustum, and cleans up
	void	Undraw_Frustum(void);

	// Tells the widget which maze to display. This causes a redraw.
	void	Set_Maze(Maze*);
};


#endif
